-----------------------------------------------------------------------------------------------
-- 'The Zone' v1.3.7a [22/08/2016] OLD WORK ALPHA VERSION
-----------------------------------------------------------------------------------------------

-- v1.3.7a (22/08/2016)
-- Updated to API 13.
-- Use new "MatchingGameLib" functions.

require "Window"
require "Apollo"
require "GameLib"
require "Unit"
require "GroupLib"
require "FriendshipLib"
require "ICCommLib"
require "PublicEvent"
require "MessageManagerLib"
require "PlayerPathLib"
require "HousingLib"
require "MatchingGameLib"
require "XmlDoc"

local TheZone = {} 
local L = Apollo.GetPackage("Gemini:Locale-1.0").tPackage:GetLocale("TheZone", true)

local TZ_VER = "1.3.7a"
local tTZ_Config = {}
	  tTZ_Config.version = TZ_VER 
	  tTZ_Config.option = {}      
	  tTZ_Config.faction = 0	  
	  tTZ_Config.status = {}	  
	  tTZ_Config.tag = {}	      
	  tTZ_Config.opacity = 0      
	  tTZ_Config.template = 1    

local tTemplate = 	{ 
     
					[1] = { sTP_Name = "default" },	
					[2] = { sTP_Name = "T2" },
					[3] = { sTP_Name = "T3" },
					[4] = { sTP_Name = "T4" },
					[5] = { sTP_Name = "T5" },	
					
					}

local tAreaUnits = {}
local tClass = 	{ 
     
				[GameLib.CodeEnumClass.Warrior]      = { sName = Apollo.GetString("ClassWarrior"), 	    	sLogo = "NewSprite:Class_Warrior_2" },		
				[GameLib.CodeEnumClass.Engineer]     = { sName = Apollo.GetString("ClassEngineer"), 	 	sLogo = "NewSprite:Class_Engineer_2" },		
				[GameLib.CodeEnumClass.Esper]        = { sName = Apollo.GetString("ClassESPER"), 		 	sLogo = "NewSprite:Class_Esper_2" },		
				[GameLib.CodeEnumClass.Medic]        = { sName = Apollo.GetString("ClassMedic"), 		 	sLogo = "NewSprite:Class_Medic_2" },		
				[GameLib.CodeEnumClass.Stalker]      = { sName = Apollo.GetString("ClassStalker"), 	    	sLogo = "NewSprite:Class_Stalker_2" },		
				[GameLib.CodeEnumClass.Spellslinger] = { sName = Apollo.GetString("ClassSpellslinger"),  	sLogo = "NewSprite:Class_Spellslinger_2" },	
						
				}

local tPath = 	{ 
     
				[PlayerPathLib.PlayerPathType_Scientist]	= { sName = Apollo.GetString("PlayerPathScientist"), 	sLogo = "CRB_PlayerPathSprites:spr_Path_Scientist_Stretch" },		
				[PlayerPathLib.PlayerPathType_Settler]		= { sName = Apollo.GetString("PlayerPathSettler"), 	 	sLogo = "CRB_PlayerPathSprites:spr_Path_Settler_Stretch" },		
				[PlayerPathLib.PlayerPathType_Soldier]     	= { sName = Apollo.GetString("PlayerPathSoldier"), 	 	sLogo = "CRB_PlayerPathSprites:spr_Path_Soldier_Stretch" },		
				[PlayerPathLib.PlayerPathType_Explorer]		= { sName = Apollo.GetString("PlayerPathExplorer"), 	sLogo = "CRB_PlayerPathSprites:spr_Path_Explorer_Stretch" },		

				}

local tRoleHealer = { sIconTag = "NewSprite:healer_1", sIconRole = "NewSprite:Cross_white", sIconRoleTopHealer = "NewSprite:Cross_orange", } 
local tFaction = 	{ 
					
					[Unit.CodeEnumFaction.DominionPlayer]	= Apollo.GetString("CRB_Dominion"),	
					[Unit.CodeEnumFaction.ExilesPlayer]		= Apollo.GetString("CRB_Exile"),	
		
					}

local tFactionLogo = 	{ 
					
					[167] = "CRB_DEMO_CreationSprites:sprDemo_CCFactionLogoExile",	
					[166] =	"CRB_DEMO_CreationSprites:sprDemo_CCFactionLogoDom", 	
							
					    }

local tColorArea_INI = {
					
                    alert			    =	"ffff8c00",				
					noalert				=	"ffffffff",				
					faction				=	"ffffffff",				
					friend				=	"ff32cd32",				
					nofaction			=	"ffff8c00",				
					guildmate		    =	"ff9370db",				
					group				=	"ff00bfff",				
					outofrange			= 	"DarkGray",				
					range				=	"ffffffff",				
					noguild				=	"DarkGray",				
					guild				=	"xkcdAlgae",			
					pvpflaged			=	"ffff0000",				
					healerconfirmed		= 	"ff32cd32",	   			
					tophealer    		= 	"ffdd6e30",				
					tophealertag    	= 	"ffffffff",				
					normal			    = 	"ffffffff",				
					dead 				=   "ff808080",				
					health100         	= 	"ffffffff",				
					health50         	= 	"AttributeName",		
					health25         	= 	"AttributeStamina",		
					
					}		

local tColorArea = 	tColorArea_INI														
local tStatus = {   

					[1] = { sText = L["TZ_FACTION_O"], 		sTextColor = tColorArea.faction, 			sColorIni = tColorArea_INI.faction, },					
					[2] = { sText = L["TZ_ENEMY_O"], 			sTextColor = tColorArea.nofaction,      	sColorIni = tColorArea_INI.nofaction, },
					[3] = { sText = L["TZ_ENEMYPVP_O"], 	sTextColor = tColorArea.pvpflaged,      	sColorIni = tColorArea_INI.pvpflaged, },
					[4] = { sText = L["TZ_FRIEND_O"], 			sTextColor = tColorArea.friend,         	sColorIni = tColorArea_INI.friend, },
					[5] = { sText = L["TZ_GROUP_O"], 			sTextColor = tColorArea.group,          	sColorIni = tColorArea_INI.group, },
					[6] = { sText = L["TZ_GUILDMATE_O"], 		sTextColor = tColorArea.guildmate,      	sColorIni = tColorArea_INI.guildmate, },
					[7] = { sText = L["TZ_DEAD_O"], 		sTextColor = tColorArea.dead,   			sColorIni = tColorArea_INI.dead, },
					[8] = { sText = "Healer TAG", 		sTextColor = tColorArea.healerconfirmed,	sColorIni = tColorArea_INI.healerconfirmed, },
					[9] = { sText = "Top Healer TAG",	sTextColor = tColorArea.tophealer, 			sColorIni = tColorArea_INI.tophealer, },
					[10] = { sText = "Normal TAG",	sTextColor = tColorArea.normal, 			sColorIni = tColorArea_INI.normal, },
				}	
					

local tTagOption = 	{
						sFont = "CRB_Interface16_BB",
						sFontColor = "red",			
						sTagSprite = "NewSprite:tag_1", 
						nTagExpire = 30, 				
						bFactionSet = false,			
						}	

local tz_uTarget = nil 
local tTargetMenu = {   

					[1] = { sNameMenu = L["TZ_INSPECT"], 	ifCan = function() return TheZone:CanMenu(tz_uTarget, 4) end, useFunction = function() tz_uTarget:Inspect() end },	
					[2] = { sNameMenu = L["TZ_BOT"],   	ifCan = function() return TheZone:CanMenu(tz_uTarget, 5) end, useFunction = function() TheZone:UseBGBot(tz_uTarget) end },	
					[3] = { sNameMenu = L["TZ_TRACK"], 	ifCan = function() return false end, useFunction = function() TheZone:ShowArrow(tz_uTarget) end },	 
					[4] = { sNameMenu = L["TZ_WHISPER"], 	ifCan = function() return TheZone:CanMenu(tz_uTarget, 0) end, useFunction = function() Event_FireGenericEvent("GenericEvent_ChatLogWhisper", tz_uTarget:GetName()) end },	
					[5] = { sNameMenu = L["TZ_GROUP"], 	ifCan = function() return TheZone:CanMenu(tz_uTarget, 1) end, useFunction = function() GroupLib.Invite(tz_uTarget:GetName()) end },	
					[6] = { sNameMenu = L["TZ_FRIEND"], 	ifCan = function() return TheZone:CanMenu(tz_uTarget, 2) end, useFunction = function() FriendshipLib.AddByUnit(FriendshipLib.CharacterFriendshipType_Friend, tz_uTarget) end }, 
					[7] = { sNameMenu = L["TZ_RIVAL"], 	ifCan = function() return false end, useFunction = function() FriendshipLib.AddByUnit(FriendshipLib.CharacterFriendshipType_Rival, tz_uTarget) end },	
					[8] = { sNameMenu = L["TZ_FOCUS"], 	ifCan = function() return false end, useFunction = function() GameLib.GetPlayerUnit():SetAlternateTarget(tz_uTarget) end },	
 						
					}			

local tOptionMenu = {
   		
					[1] = { bActived = false, bToggle = true, sIconOption = "NewSprite:option_1", sToolTips = L["TZ_OSHOWENEMY"], useFunction = function() return false end },
					[2] = { bActived = false, bToggle = true, sIconOption = "NewSprite:option_9", sToolTips = L["TZ_OTRACKMASTER"], useFunction = function() return false end },
					[3] = { bActived = true, bToggle = true, sIconOption = "NewSprite:option_4", sToolTips = L["TZ_OSHOWHEALTH"], useFunction = function() Event_FireGenericEvent("Generic_RTO", 3) end },
					[4] = { bActived = false, bToggle = true, sIconOption = "NewSprite:option_6", sToolTips = L["TZ_OCITYDISABLED"], useFunction = function() return false end },
				   	[5] = { bActived = false, bToggle = true, sIconOption = "NewSprite:option_8", sToolTips = L["TZ_OLOCK"], useFunction = function() Event_FireGenericEvent("Generic_RTO", 5) end },  
				    [6] = { bActived = false, bToggle = true, sIconOption = "NewSprite:option_3", sToolTips = L["TZ_OSHOWROLE"], useFunction = function() return false end },
				    [7] = { bActived = false, bToggle = true, sIconOption = "NewSprite:option_10", sToolTips = L["TZ_OTAGSHOW"], useFunction = function() return false end },	
 				    [8] = { bActived = false, bToggle = false, sIconOption = "NewSprite:option_2", sToolTips = L["TZ_OTEMPLATE"], useFunction = function() Event_FireGenericEvent("Generic_RTO", 8) end },
					
					}
function TheZone:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function TheZone:Init()
    Apollo.RegisterAddon(self, true, "TheZone v"..TZ_VER, nil)   
end

function TheZone:OnLoad()

	self.xmlDoc = XmlDoc.CreateFromFile("TheZone.xml")
    self.tUnitTag = {}	
	self.uLastPlayer = nil  
	tz_bTrack = false     
	self.tUnitsBacklog = {}
	self.uPlayerUnit = nil
	
	Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)	
	Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)		
	Apollo.RegisterEventHandler("UnitDestroyed", "OnUnitDestroyed", self)
	Apollo.RegisterEventHandler("ChangeWorld", "OnChangeWorld", self)	
	Apollo.RegisterTimerHandler("Unit_Refresh", "OnTimerRefresh", self)
	Apollo.CreateTimer("Unit_Refresh", 0.1, true)
	Apollo.RegisterTimerHandler("Timer_Arrow", "OnTimerArrow", self)				
	Apollo.RegisterSlashCommand("thezone", "OnSlash", self)	
	Apollo.RegisterSlashCommand("Thezone", "OnSlash", self)	
	Apollo.RegisterSlashCommand("tz", "OnSlash", self)					
    Apollo.RegisterSlashCommand("Tz", "OnSlash", self)	
   
    self.wndCount = Apollo.LoadForm("TheZone.xml", "FrameCount", nil, self)
    self.wndFrame_OpenRange = self.wndCount:FindChild("FrameArea")
	
    self.nCountHostile = 0
   
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
	Apollo.RegisterEventHandler("Generic_OnWShow", "OnWShow", self)	
	
    self:SetOptionMenu()
	Apollo.RegisterEventHandler("Generic_RTO", "RTO_FunctionCall", self)
	self.doSetMiniSize = true
 end

function TheZone:RTO_FunctionCall(nId)
    if nId == 3 then self:RTO_ShowHealth(self.wndCount) end 
   	if nId == 5 then self:RTO_LockToggle(self.wndCount) end 
    if nId == 8 then self:RTO_UseTemplate() end 			
end

function TheZone:RTO_LockToggle(wndControl)
	wndControl:SetStyle("Moveable", not tOptionMenu[5].bActived)
end 

function TheZone:RTO_GetNextTemplate()
    local nTP = tTZ_Config.template
    local nTPAll = #tTemplate
	if nTP == nTPAll then nTP = 0 end
	nTP = nTP + 1
	tTZ_Config.template = nTP
end

function TheZone:RTO_UseTemplate()
	local tTemp = tAreaUnits
	for _,oWnd in pairs(tTemp) do
		if oWnd.window ~= nil then	self:RemovePlayerWnd(_) end
	end
	
    self:RTO_GetNextTemplate()
    self.doSetMiniSize = true
end

function TheZone:RTO_ShowHealth(wndControl)
	local tChildren = wndControl:FindChild("FrameArea"):GetChildren()
	local nTP = tTZ_Config.template

	if tOptionMenu[3].bActived then
		for _=1,#tChildren do
			Apollo.LoadForm(self.xmlDoc, "HealthWnd_T_"..nTP, tChildren[_], self)
		    tChildren[_]:FindChild("HealthWnd_T_"..nTP):SetName("HealthWnd")
		end	
	elseif not tOptionMenu[3].bActived then
		
		for _=1,#tChildren do
		    local wnd = tChildren[_]:FindChild("HealthWnd")
		    if wnd then wnd:Destroy() end
		end	
	end
end

function TheZone:AddPlayer(sName)

    local uTarget = GameLib.GetPlayerUnitByName(sName)
	local uPlayer = GameLib.GetPlayerUnit()
    if uTarget == nil then return end 
   
    if tAreaUnits[sName] == nil then

    	tAreaUnits[sName] = { 
			                  class =		uTarget:GetClassId(),
			                  faction = 	uTarget:GetDispositionTo(uPlayer),			
     						}
		return true
    end
end

function TheZone:AddPlayerWnd(sName, wndFrame)

    if tAreaUnits[sName].window == nil then

        local wndTargetFrame = wndFrame
		local nTP = tTZ_Config.template
		local wnd = Apollo.LoadForm(self.xmlDoc, "Wnd_Template_"..nTP, wndTargetFrame, self)
		
		if tOptionMenu[3].bActived then
			Apollo.LoadForm(self.xmlDoc, "HealthWnd_T_"..nTP, wnd, self)
			wnd:FindChild("HealthWnd_T_"..nTP):SetName("HealthWnd")	
		end
		
		local tData = { name = sName, class = tAreaUnits[sName].class, faction = tAreaUnits[sName].faction }
		wnd:SetData(tData)
		tAreaUnits[sName].window = wnd
		self:Update_Name(wnd, sName)
		self:Update_Class(wnd, sName)
		self:Update_Face(wnd, sName)
		self.doArrange = true
	end	
end

function TheZone:RemovePlayer(sName)

	if tAreaUnits[sName] ~= nil then
		self:RemovePlayerWnd(sName)
		tAreaUnits[sName] = nil
		return true
	end 
end

function TheZone:RemovePlayerWnd(sName)

	if tAreaUnits[sName].window ~= nil then
                
    	tAreaUnits[sName].window:DestroyChildren()         
        tAreaUnits[sName].window:Destroy()
        tAreaUnits[sName].window = nil 
	   	self.doArrange = true	
	end  
end

function TheZone:Update_OpenRange(sName)

    local uTarget = GameLib.GetPlayerUnitByName(sName)
   	local nRange = self:DistanceToUnit(uTarget) 

    if nRange <= 300 or (nRange ~= nil and not self:IsSameFaction(uTarget)) then  
	
		self:AddPlayerWnd(sName, self.wndFrame_OpenRange)
		self:Update_Wnd(uTarget, sName)
	else 
		self:RemovePlayerWnd(sName)
   	end 
end

function TheZone:Update_Wnd(uTarget, sName)

    if uTarget == nil then return end

    self.sColorArea = self:SetColorArea(uTarget)
	self.sColorDist = self:SetColorRange(uTarget)

	if uTarget:IsDead() then
		self.sColorArea = tColorArea.dead
		self.sColorDist = tColorArea.dead
	end

	local nTP = tTZ_Config.template
	local wnd = tAreaUnits[sName].window
    
    self:Update_Color(wnd)
    self:Update_Level(wnd, uTarget)
    self:Update_Range(wnd, uTarget)
    self:Update_Combat(wnd, uTarget)
	self:Update_Tag(wnd, uTarget)
	self:Update_Role(wnd, uTarget)
	self:Update_Track(wnd, uTarget)
	
    if tOptionMenu[3].bActived then 
		self:Update_Health(nTP, wnd, uTarget) 
		self:Update_Shield(nTP, wnd, uTarget)
	end	
	self:Update_Rival(wnd, uTarget)
end

function TheZone:Update_Face(wndControl, sName)
    
    local uTarget = GameLib.GetPlayerUnitByName(sName)
	local wndFace = wndControl:FindChild("FaceWnd")
	if wndFace == nil then return end
	
	wndFace:SetCostume(uTarget)	
	wndFace:Show(true, false)
end

function TheZone:Update_Class(wndControl, sName)

	local sClass = self:ShowClass(sName)
	local wndClass = wndControl:FindChild("ClassWnd")
	if wndClass == nil then return end
	wndClass:SetSprite(sClass)
end

function TheZone:Update_Level(wndControl, uTarget)
	
	local sLevel = uTarget:GetLevel() 
	local wndLevel = wndControl:FindChild("LevelWnd")
	if wndLevel == nil then return end

	wndLevel:SetText(sLevel)
	wndLevel:SetTextColor(self.sColorArea)	
end

function TheZone:Update_Name(wndControl, sName)
   
	local nNameLenght = string.len(sName)
	if nNameLenght >= 16 then sName = string.sub(sName,1,15) .. ".." end
	
	local wndName = wndControl:FindChild("NameWnd")
	if wndName == nil then return end
	
	wndName:SetText(sName)
	wndName:SetTextColor(self.sColorArea)	
end

function TheZone:Update_Color(wndControl)

	local wndName = wndControl:FindChild("NameWnd")
	if wndName == nil then return end
	wndName:SetTextColor(self.sColorArea)	
end

function TheZone:Update_Range(wndControl, uTarget)

	local nRange = self:DistanceToUnit(uTarget)
	local sRange = string.format("%.2f m", nRange)
	if nRange >= 270 then sRange = "-" end
	
	local wndRange = wndControl:FindChild("RangeWnd")
	if wndRange == nil then return end
	wndRange:SetText(sRange)
	wndRange:SetTextColor(self.sColorDist)	
end

function TheZone:Update_Combat(wndControl, uTarget)

	local sInCombat = self:IsInCombat(uTarget)
	local wndCombat = wndControl:FindChild("CombatWnd")
	if wndCombat == nil then return end
	wndCombat:SetSprite(sInCombat)
end

function TheZone:Update_Tag(wndControl, uTarget)

	local wndTag = wndControl:FindChild("TagWnd")
	wndTag:Show(tOptionMenu[7].bActived)
	if not wndTag:IsShown() then return end
	
	local sNumTag = ""
	if (self:IsSameFaction(uTarget) == tTagOption.bFactionSet) then	
	     sNumTag = self:GetAutoTag(uTarget:GetName())
	end 
	wndTag:SetText(sNumTag)
end

function TheZone:Update_Role(wndControl, uTarget)

	local wndRole = wndControl:FindChild("RoleWnd")
	if wndRole == nil then return end

	wndRole:Show(tOptionMenu[6].bActived)
	if not wndRole:IsShown() then return end
	
	local sRole = ""
	
	if self:GetHealerBase(uTarget) then
		
		if self:IsConfirmedHealer(uTarget, self.nMinHeal)  then 
		  	if uTarget:GetName() == self.sTopHealer then  
				sRole = tRoleHealer.sIconRoleTopHealer
		    else
				sRole = tRoleHealer.sIconRole
			end	
		end
	end	
	wndRole:SetSprite(sRole)
end

function TheZone:Update_Track(wndControl, uTarget)

	local sTrack = self:TrackStatus(uTarget)
	local wndTrack = wndControl:FindChild("TrackWnd")
	if wndTrack == nil then return end
	wndTrack:SetSprite(sTrack)
end

function TheZone:Update_Health(nTP, wndControl, uTarget)

  	local wndHealth = wndControl:FindChild("HealthWnd")
  	if wndHealth == nil then return end

  	local nTP = tTZ_Config.template
 
   	if nTP ~= 1 then
  		wndHealth:SetMax(uTarget:GetMaxHealth()) 	
  		wndHealth:SetFloor(0) 					
  		local nHeal = uTarget:GetHealth()

  		wndHealth:SetProgress(nHeal) 			
   		return
  	end 
		
	local sHealth = ""
	local sColorHealth = self.sColorArea	

	local nHealthPercent = self:GetHealthPercent(uTarget)
	sColorHealth = self:SetColorHealth(nHealthPercent)
	if nHealthPercent ~= 0 then sHealth = nHealthPercent .. "%" end
	wndHealth:SetText(sHealth)
	wndHealth:SetTextColor(sColorHealth)
end

function TheZone:Update_Shield(nTP, wndControl, uTarget)

  	local wndShield = wndControl:FindChild("ShieldWnd")
    if wndShield == nil then return end
 
  	if nTP == 2 then
  		wndShield:SetMax(uTarget:GetShieldCapacityMax()) 	
  		wndShield:SetFloor(0) 								
  		local nShield = uTarget:GetShieldCapacity()
  		wndShield:SetProgress(nShield) 						
   		return
   	end 
end

function TheZone:Update_Rival(wndControl, uTarget)

	local sIsRival = self:IsRival(uTarget)
	local wndRival = wndControl:FindChild("RivalWnd")
	if wndRival == nil then return end
	wndRival:SetSprite(sIsRival)
end

function TheZone:OnHTLPrepPhase()
	
	self:ReinitTag(false)
	tTagOption.bFactionSet = false	
	tAreaUnits = {}	
end

function TheZone:OnInterfaceMenuListHasLoaded()
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "TheZone", {"Generic_OnWShow", "", "NewSprite:option_5"})
	self:UpdateInterfaceMenuAlerts()
end

function TheZone:OnWShow()
	self:OnSlash("tz")
end

function TheZone:UpdateInterfaceMenuAlerts()
	Event_FireGenericEvent("InterfaceMenuList_AlertAddOn", "TheZone", {self.nCountHostile > 0, "v"..TZ_VER, self.nCountHostile})
end

function TheZone:OnUnitCreated(unit)

    if unit == nil then return end
  
	local nUnitId = unit:GetId() 
    if self.uPlayerUnit == nil then
		self.tUnitsBacklog[nUnitId] = unit
		return
	end
    
	if self:DoUseUnit(unit) == false then return end
    if tTZ_Config.faction == 0 then tTZ_Config.faction = GameLib.GetPlayerUnit():GetFaction() end
    if self.nMinHeal == nil and MatchingGameLib.IsInPvpGame() then self:GetMinHeal() end
 	
	if self:AddPlayer(unit:GetName()) == true then 
		if unit:IsACharacter() and self:IsSameFaction(unit) == tTagOption.bFactionSet then self:SetAutoTag(unit:GetName()) end 
	    self:GetCounterColor()
	end 
end

function TheZone:OnUnitDestroyed(unit)

    if unit == nil then return end

    local nUnitId = unit:GetId()     
	if self.uPlayerUnit == nil then
		self.tUnitsBacklog[nUnitId] = unit
		return
	end
   
    if self:DoUseUnit(unit) == false then return end
   	if self:RemovePlayer(unit:GetName()) then
		
		if unit:IsACharacter() and self:IsSameFaction(unit) == tTagOption.bFactionSet then self:AwayTimerTagStart(unit:GetName()) end
		self:GetCounterColor()
	end
end

function TheZone:DoUseUnit(unit)
    
    local unit = unit
	if (unit == nil) or (not unit:IsACharacter()) then return false end
	return true
end

function TheZone:IsInCityHome()
	
    local nZoneId = GameLib.GetCurrentZoneMap().id
    if nZoneId == nil then return false end
	local nIllium = GameLib.MapZone.Illium 		
	local nThayd = GameLib.MapZone.Thayd  		
    local bInHome = HousingLib.IsHousingWorld() 

	if (nZoneId == nIllium or 
		nZoneId == nThayd) or 
		bInHome then return true end
	return false
end 

function TheZone:IsInCombat(unit)
    
    local unit = unit
	if not unit:IsInCombat() then return "" end
	local sIconCombat = "CRB_WarriorSprites:sprWar_SmallSkullRed"
	return sIconCombat
end 

function TheZone:IsRival(unit)
      
    local unit = unit
	if not unit:IsRival() then return "" end
	local sIconRival = "ClientSprites:LootCloseBox_Holo"
	return sIconRival
end 

function TheZone:ShowClass(sName)
   	local sIconClass = tClass[tAreaUnits[sName].class].sLogo
	return sIconClass
end 

function TheZone:SetColorArea(unit)

	if unit == nil then return end
	local uTarget = unit
		
    local bTargetIsFriend = uTarget:IsFriend() or unit:IsAccountFriend()
	local  bTargetInGroup = uTarget:IsInYourGroup()
	local  bTargetPvpFlag = uTarget:IsPvpFlagged()
	                                
	if not self:IsSameFaction(uTarget) and bTargetPvpFlag then return tColorArea.pvpflaged end
	if not self:IsSameFaction(uTarget) then return tColorArea.nofaction
	elseif bTargetInGroup then return tColorArea.group
	elseif bTargetIsFriend then return tColorArea.friend
	end
   
	local sPlayerGuildName = GameLib.GetPlayerUnit():GetGuildName()
	if sPlayerGuildName ~= nil then 
	  	local sTargetGuildName = uTarget:GetGuildName()
		if sPlayerGuildName == sTargetGuildName then return tColorArea.guildmate end
	end
	
    return tColorArea.faction
end

function TheZone:SetColorRange(unit)
    
    local unit = unit
    local nTargetRange = self:DistanceToUnit(unit)
	if nTargetRange > 130 then return tColorArea.outofrange end
	return tColorArea.range
end

function TheZone:SetColorHealth(nHealthPercent)
    	
    local nHealth = nHealthPercent
	if nHealth >= 26 and nHealth <=50 then return tColorArea.health50 end
	if nHealth <= 25 then return tColorArea.health25 end
	return tColorArea.health100
end

function TheZone:DistanceToUnit(uTarget)
    
	if uTarget == nil then return 0 end
	local uPlayer = GameLib.GetPlayerUnit()
	
	if (uPlayer == nil) then return 0 end 
 	local posPlayer = uPlayer:GetPosition()
    if uTarget:GetPosition() == nil then return 0 end 	

	local posTarget = uTarget:GetPosition()
	local nDeltaX = posTarget.x - posPlayer.x
	local nDeltaY = posTarget.y - posPlayer.y
	local nDeltaZ = posTarget.z - posPlayer.z
	
	local nDistance = math.sqrt(math.pow(nDeltaX, 2) + math.pow(nDeltaY, 2) + math.pow(nDeltaZ, 2))
	return nDistance
end 

function TheZone:IsSameFaction(uTarget)
	
	if uTarget == nil then return end
	local uPlayer = GameLib.GetPlayerUnit()
	
	local nDisposition = uTarget:GetDispositionTo(uPlayer)
	
	if nDisposition == Unit.CodeEnumDisposition.Friendly then 
		return true
	end 
	
	if nDisposition == Unit.CodeEnumDisposition.Hostile then 
		return false 
	end 
end

function TheZone:GetHealthPercent(uTarget)

    if uTarget == nil then return 100 end
    
	local nMaxHealth = uTarget:GetMaxHealth()
	local nHealth = uTarget:GetHealth()
	local nHealthInPerc = math.floor((nHealth / nMaxHealth * 100) + 0.5)
	return nHealthInPerc
end

function TheZone:GetAutoTag(sName)
    		
	local tData = self.tUnitTag[sName]
	if tData ~= nil then 
		return tostring(tData.tag)
	else
		return ""   
	end
 end

function TheZone:AwayTimerTagStart(sName)
	local tData = self.tUnitTag[sName]
	if tData ~= nil then self.tUnitTag[sName].awaytimer = os.time() end
end 
 
function TheZone:FreeTag()
 	for _,AwayTaged in pairs(self.tUnitTag) do
		if AwayTaged.awaytimer ~= 0 then
			local nActualTime = os.time()	
			if (AwayTaged.awaytimer + tTagOption.nTagExpire) < nActualTime then
				local tData = self.tUnitTag[_]
				if tData.window ~= nil then tData.window:Destroy() end
				self.tUnitTag[_] = nil
			end					
		end  
    end 
end  

function TheZone:SetAutoTag(sName)
	local tData = self.tUnitTag[sName]
	
	if tData ~= nil then
		if (tData.awaytimer + tTagOption.nTagExpire) > os.time() then
			self.tUnitTag[sName].awaytimer = 0 
			return
		end
	end
	
	self.tUnitTag[sName] = {
							awaytimer = 0, 		
							tag = self:Tag()	
	                         }
end

function TheZone:Tag()
			
	local bSameTag = true
	local nTag = 0
	local nTagDispo 
	local bFindTag = false
	
	repeat
		if bSameTag == true then
			nTag = nTag + 1 
		else 
			nTagDispo = nTag
			bFindTag = true
		end	
		bSameTag = false
			
		for _,ComparTag in pairs(self.tUnitTag) do
		    if ComparTag.tag == nTag then bSameTag = true end
		end 

	until bFindTag == true
	return nTagDispo
end

function TheZone:ShowTagForUnit(sName)

    local uTarget = GameLib.GetPlayerUnitByName(sName)
    if uTarget == nil then return end 
	if tOptionMenu[7].bActived == false then self:RemoveWndTag(sName) return end
	if self:GetHealerBase(uTarget) then self:UpdateHealerTag(sName) end
	
	local tScreenPos = GameLib.GetUnitScreenPosition(uTarget)
	local nRange = self:DistanceToUnit(uTarget)
	local bOccluded = uTarget:IsOccluded()
	local bIsInMount = uTarget:IsMounted()
 
	if uTarget:IsDead() and tScreenPos.bOnScreen == false then self:RemoveWndTag(sName) return end

	if tScreenPos.bOnScreen == false then self:RemoveWndTag(sName) return end 
	if tScreenPos.bOnScreen == true and  nRange >= 121 then self:RemoveWndTag(sName) return end
	if tScreenPos.bOnScreen == true and bOccluded  == true and  nRange <= 120  then self:RemoveWndTag(sName) return end
	if tScreenPos.bOnScreen == false and bOccluded  == true and  nRange <= 120  then self:RemoveWndTag(sName) return end
	if tScreenPos.bOnScreen == true and bOccluded  == false and  nRange <= 120  then self:CreateWndTag(sName) return end   
end

function TheZone:CreateWndTag(sName)

    local uTarget = GameLib.GetPlayerUnitByName(sName)
    if uTarget == nil then return end 
	
	local tData = self.tUnitTag[sName]
	
	if tData.window ~= nil then
		return
	end

	local wndTag = Apollo.LoadForm(self.xmlDoc, "TagForm", "InWorldHudStratum", self)
	wndTag:SetUnit(uTarget, 1)	
	self.tUnitTag[sName].window = wndTag 
	tData.window:SetFont(tTagOption.sFont)	
	tData.window:SetTextColor(tTagOption.sFontColor)
	tData.window:SetText(tData.tag)
	tData.window:SetSprite(tTagOption.sTagSprite)
	tData.window:SetBGColor(tColorArea.normal)
end

function TheZone:UpdateHealerTag(sName)
   
    local uTarget = GameLib.GetPlayerUnitByName(sName)
    if uTarget == nil then return end
	local tData = self.tUnitTag[sName]
	
	if tData.window ~= nil then
	    if self:IsConfirmedHealer(uTarget, self.nMinHeal) then
						
			self:SizeTag(tData.window)
			tData.window:SetSprite(tRoleHealer.sIconTag)
			self.sColor = tColorArea.healerconfirmed
			self.sColorTag = tTagOption.sFontColor
			if self:IsTopHealer(uTarget) == true then
				self.sColor = tColorArea.tophealer
				self.sColorTag = tColorArea.tophealertag
			end
			tData.window:SetBGColor(self.sColor)
			tData.window:SetTextColor(self.sColorTag)
		end
	end
end

function TheZone:RemoveWndTag(sName)

    local tData = self.tUnitTag[sName]
	if tData.window == nil then
		return
	end
	
	tData.window:Destroy()
	self.tUnitTag[sName].window = nil
end

function TheZone:UpdateTag()
	
	for _,Actual in pairs(self.tUnitTag) do
		self:ShowTagForUnit(_)
	end 
	self:FreeTag()
end

function TheZone:UpdateTagFont()
	
	for _,Tag in pairs(self.tUnitTag) do
		if Tag.window ~= nil then
			Tag.window:SetFont(tTagOption.sFont)	
			Tag.window:SetTextColor(tTagOption.sFontColor) 
		end	
	end 
end

function TheZone:UpdateTags()
	
	for _,Tag in pairs(self.tUnitTag) do
		if Tag.window ~= nil then
			Tag.window:SetSprite(tTagOption.sTagSprite)
			Tag.window:SetBGColor(tColorArea.normal)
		end	
	end 
end

function TheZone:GetHealerBase(uTarget)
    
    if uTarget == nil then return end
    local nClass = uTarget:GetClassId() 
	if nClass <= 2 or nClass == 5 then return false end
	return true
end

function TheZone:GetMinHeal()
  	local nPlayerLevel = GameLib.GetPlayerLevel()
	if nPlayerLevel == nil then self.nMinHeal = 100 return end
   	if nPlayerLevel == 14 then self.nMinHeal = 2500 end  
	if nPlayerLevel == 29 then self.nMinHeal = 5000 end  
	if nPlayerLevel >= 49 then self.nMinHeal = 10000 end 
end

function TheZone:IsConfirmedHealer(uTarget, nHeal) 

    if uTarget == nil then return end
 	for idx, peCurrent in pairs(PublicEvent.GetActiveEvents()) do
		if peCurrent:HasLiveStats() then
			local eType = peCurrent:GetEventType()
			if eType == PublicEvent.PublicEventType_PVP_Warplot or eType == PublicEvent.PublicEventType_PVP_Battleground_Vortex or eType == PublicEvent.PublicEventType_PVP_Arena
			or eType == PublicEvent.PublicEventType_PVP_Battleground_HoldTheLine or eType == PublicEvent.PublicEventType_PVP_Battleground_Sabotage
			or eType == PublicEvent.PublicEventType_PVP_Battleground_Cannon then
				local tLiveStats = peCurrent:GetLiveStats()
				for idx, uPlayer in pairs(tLiveStats.arParticipantStats) do
					sCompare = string.find(uTarget:GetName(), uPlayer.strName)
					if sCompare ~= nil then
						if self:GetHealerBase(uTarget) and (uPlayer.nHealed ~= 0 and uPlayer.nHealed >= nHeal) then 
							return true
						end
					end
				end
			end
		end
	end
   return false 
end

function TheZone:IsTopHealer(unit) 
   
    if unit == nil then return end
	local sName = unit:GetName()
	
	local tHealers = {}
	for idx, peCurrent in pairs(PublicEvent.GetActiveEvents()) do
		if peCurrent:HasLiveStats() then
        local tLiveStats = peCurrent:GetLiveStats()
			for idx, uPlayer in pairs(tLiveStats.arParticipantStats) do
				if self:IsSameFaction(GameLib.GetPlayerUnitByName(uPlayer.strName)) == tTagOption.bFactionSet then 
					table.insert(tHealers,{ name = uPlayer.strName, nMaxHeal = uPlayer.nHealed,})	
				end	
			end
		end	
	end	
		
	table.sort(tHealers, function(a,b) return (a.nMaxHeal > b.nMaxHeal) end)
	if #tHealers ~= 0 and tHealers[1].name == sName then 
		self.sTopHealer = sName			
		return true
	end
	return false
end

function TheZone:AddUnitsFromBacklog()
	for nUnitId, uUnit in pairs(self.tUnitsBacklog) do
		if uUnit:IsValid() then
			self:OnUnitCreated(uUnit)
		end
	end
	self.tUnitsBacklog = {}
end

function TheZone:OnChangeWorld()
	self.uPlayerUnit = nil
	self:ReinitTag(false)
	tTagOption.bFactionSet = false	
	tAreaUnits = {}	
	self.nMinHeal = nil
end

function TheZone:OnTimerRefresh()

    local sMem = self:GetMemory("TheZone")
    local sFPS = self:GetFPS()
    local sDebug = sMem .. " " .. sFPS
    self.wndCount:FindChild("DEBUG"):SetText(sDebug)
   
    if self.uPlayerUnit == nil then
		self.uPlayerUnit = GameLib.GetPlayerUnit()
		if self.uPlayerUnit ~= nil then
			self:AddUnitsFromBacklog()
		end
		return
	end
   
	local nCountUnit = self:TableLength(tAreaUnits)
	self.wndCount:FindChild("AreaWnd"):SetText("(" .. tostring(nCountUnit) .. ")")
	
	for _, oPlayer in pairs(tAreaUnits) do  	      
	    local uTarget = GameLib.GetPlayerUnitByName(_)
	    if uTarget == nil then return end
		if tOptionMenu[1].bActived and self:IsSameFaction(uTarget) == true then self:RemovePlayerWnd(_)
        else
		    self:Update_OpenRange(_)
	    end
	end
    
	self.nLastAnchor, t,r,b = self.wndCount:GetAnchorOffsets()
	if self.doArrange then
    	self:Set_Arrange(self.wndCount:FindChild("FrameArea"))
		self.doArrange = false
	end
	
    if self.doSetMiniSize then 
		self:SetMinimum_Size(self.wndCount)
		self.doSetMiniSize = false
	end
    if self:TableLength(self.tUnitTag) ~= 0 then self:UpdateTag()end
end

function TheZone:SetHideShowInCity()

    local sColor = "white"
	self.bDoUse = true
  
	if tOptionMenu[4].bActived then
		if self:IsInCityHome() and self.wndCount:IsShown() then 
			sColor = "gray"			
			self.bDoUse = false
		end
	
		if not self:IsInCityHome() and not self.wndCount:IsShown() then 
			sColor = "white"			
			self.bDoUse = true
		end
	end
   
	self.wndCount:FindChild("AreaWnd"):Show(self.bDoUse)
	self.wndCount:SetTextColor(sColor)	 
	self.wndCount:FindChild("AreaGrid"):Show(self.bDoUse)
end

function TheZone:GetCounterColor()
	
	local cCountColor = tColorArea.noalert
	local nInc = 0
	for _, oPlayer in pairs(tAreaUnits) do  	
		if oPlayer.faction == 0 then
			nInc = nInc + 1 
		end
	end
	self.nCountHostile = nInc
	
	if self.nCountHostile ~= 0 then cCountColor = tColorArea.alert end
	self.wndCount:FindChild("AreaWnd"):SetTextColor(cCountColor)
	self:UpdateInterfaceMenuAlerts()
end

function TheZone:TableLength(tArray)

    local tArray = tArray
	local nCount = 0
	for _ in pairs(tArray) do nCount = nCount + 1 end
	return nCount
end

function TheZone:OnSlash(sCommand, sOption)

	if sOption == "mem" then 
		self.wndCount:FindChild("DEBUG"):Show(not self.wndCount:FindChild("DEBUG"):IsShown(), true) 
		return
    end

	if sOption == "option" then 
		self:ShowHideOption( nil, nil, 0)
        return
    end

	if sOption == "tagswitch" then 
		tTagOption.bFactionSet = not tTagOption.bFactionSet
		self:ReinitTag(true) 
		return
	end

	if sOption == "ntagfont" then 
			
		local nActualIndex = 0
		local tFont = Apollo.GetGameFonts()
		for i=1,#tFont do
			if tTagOption.sFont == tFont[i].name then nActualIndex = i end
		end
		
		nActualIndex = nActualIndex + 1
		if nActualIndex > #tFont then nActualIndex = 1 end
		tTagOption.sFont = tFont[nActualIndex].name
		self:UpdateTagFont()
		tFont = {} 
		return
	end
	
	self.wndCount:Show(not self.wndCount:IsShown(), true) -- with 'true' we have no fade transition
	
	if self.wndCount:IsShown() then
	   	self:ReinitTag(true) 
		Apollo.CreateTimer("Unit_Refresh", 0.1, true)
	else
		Apollo.StopTimer("Unit_Refresh")
		self:ReinitTag(false) 
	end	
end

function TheZone:ReinitTag(bTagStatus)
        
	local bTagSet = bTagStatus
	Apollo.RemoveEventHandler("UnitEnteredCombat", self)	
	Apollo.RemoveEventHandler("UnitCreated", self)		
	Apollo.RemoveEventHandler("UnitDestroyed", self)	
	
	for k in pairs (self.tUnitTag) do
		if self.tUnitTag[k].window ~= nil then self.tUnitTag[k].window:Destroy() end
	end
	
	self.tUnitTag = {}
	if bTagSet == true then
		for _ in pairs (tAreaUnits) do
			local uUnit = GameLib.GetPlayerUnitByName(_)
			if self:IsSameFaction(uUnit) == tTagOption.bFactionSet then self:SetAutoTag(_) end
		end
    end 		
	
	Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)	
	Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)		
	Apollo.RegisterEventHandler("UnitDestroyed", "OnUnitDestroyed", self)	
end

function TheZone:CanMenu(unit, nId)

	local uTarget =  unit
	if uTarget  == nil then return end
	if nId == 5 then return self:AddonIsUp("BGBot") end
	if nId == 4 then return not self:IsSameFaction(uTarget) end
	if nId == 3 then return self:IsSameFaction(uTarget) end
    if not self:IsSameFaction(uTarget) then return true end	
	if nId == 1 then return GroupLib.InGroup(uTarget:GetName()) end
    if nId == 2 then return uTarget:IsFriend() or uTarget:IsAccountFriend() end
    return false
end

function TheZone:AddonIsUp(sAddOnName)

    local sAddOnName = sAddOnName
   	local aAddon = Apollo.GetAddon(sAddOnName)
    if aAddon ~= nil then return false end
	return true
end

function TheZone:ShowArrow(unit)

	if unit == nil then return end
	self.uTargetArrow = unit
	if self.uTargetArrow ~= self.uLastTarget then
	   	Apollo.CreateTimer("Timer_Arrow",1,self)	
	    tz_bTrack = true
		self.uLastTarget = self.uTargetArrow
	elseif self.uTargetArrow == self.uTargetArrow then
	    if tOptionMenu[2].bActived then self:UseTrackMaster(self.uTargetArrow, false) end
      	Apollo.StopTimer("Timer_Arrow")
	    tz_bTrack = false
		self.uLastTarget = nil
	end
end 

function TheZone:OnTimerArrow()
    
	if not tOptionMenu[2].bActived then self.uTargetArrow:ShowHintArrow() end
	if tz_bTrack == true and tOptionMenu[2].bActived then 
		self:UseTrackMaster(self.uTargetArrow, true) 
	end
				
	if tz_bTrack == true and not tOptionMenu[2].bActived then 	
		self:UseTrackMaster(self.uTargetArrow, false)
	end		
end

function TheZone:UseBGBot(unit)

	if unit == nil then return end
	local unit = unit
	local aBotAddon = Apollo.GetAddon("BGBot")
      
   	if aBotAddon ~= nil then 
       	local uTarget = unit 
    	local sName = uTarget:GetName()
	    aBotAddon:ReportBot(sName)
	end
end

function TheZone:TrackStatus(unit)

	if unit == nil then return end
	local unit = unit

	if self.uTargetArrow == nil then return "" end
	if unit:GetId() ~= self.uTargetArrow:GetId() then return "" end
	if tz_bTrack == false then return "" end
	if tz_bTrack == true then return "CRB_Basekit:kitIcon_Holo_Forward" end
end 

function TheZone:UseTrackMaster(unit, bOnOff)

	if unit == nil then return end
	local unit = unit
    local bOnOff = bOnOff
    local aTrackAddon = Apollo.GetAddon("TrackMaster")
    if aTrackAddon ~= nil and bOnOff == true then 
       	local uTarget = unit 
    	aTrackAddon:SetTarget(uTarget, -1, 1)
	elseif aTrackAddon ~= nil and bOnOff == false then
    	aTrackAddon:SetTarget(nil, nil, 1)
	end	
end

function TheZone:inTable(tTable, item)
   	for key=1,#tTable do
		if tTable[key] == item then return key end
	end	
	return false
end

function TheZone:OnMouseAreaClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	
	local sName = wndHandler:GetData().name	
	local uTarget = GameLib.GetPlayerUnitByName(sName)
	
	if uTarget == nil then return end
	if (eMouseButton == 0) then	
		GameLib.SetTargetUnit(uTarget)
	end
	if (eMouseButton == 1) then self:SetTargetMenu(uTarget) end
end

function TheZone:SetOptionMenu()
	
	for _=1,#tOptionMenu do
		self.wndBtnOption = Apollo.LoadForm(self.xmlDoc, "BtnOption", self.wndCount:FindChild("Frame_Option"), self)
		self.wndBtnOption:SetData(_)
		self.wndBtnOption:SetName("Option".. _)
		self.wndBtnOption:SetSprite(tOptionMenu[_].sIconOption)
		self.wndBtnOption:SetStyle("AutoFade", not tOptionMenu[_].bActived) 
	end
	self.wndCount:FindChild("Frame_Option"):ArrangeChildrenHorz()    
end

function TheZone:OnOptionMenuClick( wndHandler, wndControl, eMouseButton)

	if (eMouseButton == 0) then
		local IdOption = wndControl:GetData()
		local OptionM = tOptionMenu[IdOption]
		if tOptionMenu[IdOption].bToggle then 
			tOptionMenu[IdOption].bActived  = not tOptionMenu[IdOption].bActived	
			wndControl:SetStyle("AutoFade", not tOptionMenu[IdOption].bActived) 				
		end
		OptionM.useFunction()
	end
end

function TheZone:SetTargetMenu(uTarget)
   
	if uTarget == nil then return end
	local uTarget = uTarget
	sName = uTarget:GetName()	
	local nXYmouse = Apollo.GetMouse()
    local nLeft = nXYmouse.x
 	local nTop = nXYmouse.y
	
    self:DestroyMenu()
	if tAreaUnits[sName] == nil then return end
	self.wndMenu = Apollo.LoadForm(self.xmlDoc, "TargetMenu", nil, self)
	tz_uTarget = uTarget
	local setName = self.wndMenu:FindChild("TargetName")
	setName:SetText(sName)
	local sFactionArt = self:GetFactionLogo(uTarget)
	local setFactionLogo = self.wndMenu:FindChild("FactionWnd")
	setFactionLogo:SetSprite(sFactionArt)
	local setClassLevel = self.wndMenu:FindChild("TargetClassLevel")
	setClassLevel:SetText(tClass[tAreaUnits[sName].class].sName .. " " .. uTarget:GetLevelString())
	local setPath = self.wndMenu:FindChild("TargetPath")
	local nPathId = uTarget:GetPlayerPathType()
	setPath:SetText(tPath[nPathId].sName)
	local sGuildName = uTarget:GetGuildName()
	local sColorGuild = tColorArea.guild
	if sGuildName == nil then 
		sGuildName = L["TZ_TMGUILD"]
		sColorGuild = tColorArea.noguild
	end
	local setGuild = self.wndMenu:FindChild("TargetGuild")
	setGuild:SetTextColor(sColorGuild)
	setGuild:SetTextRaw("<"..sGuildName..">")
	local setHead = self.wndMenu:FindChild("wndHead")
	setHead:SetCostume(uTarget)	
	self.nBtnMenu = 0
	for i=1,#tTargetMenu do
		local TargetM = tTargetMenu[i]
		if TargetM.ifCan() == false then 
			self.wndBtnMenu = Apollo.LoadForm(self.xmlDoc, "BtnMenu_", self.wndMenu:FindChild("Frame_BtnMenu"), self)
			self.wndBtnMenu:SetData(i)
			self.wndBtnMenu:FindChild("BtnMenuText"):SetText(TargetM.sNameMenu)
			self.nBtnMenu = self.nBtnMenu + 1
		end
	end
	
	self.wndMenu:FindChild("Frame_BtnMenu"):ArrangeChildrenVert(1)
	local nHeaderSize = self.wndMenu:FindChild("HeaderWnd"):GetHeight()
	local nBtnMenuSize = self.wndMenu:FindChild("BtnMenu_"):GetHeight()
	local nBtnMenusSize = nBtnMenuSize * self.nBtnMenu
	local nHeightSize = (nHeaderSize + nBtnMenusSize) + 40
	local nGuildLenght = string.len(sGuildName) 	
	local nCharLenght = string.len(sName) 
	local nWidthSize = 272
	
	if nGuildLenght > nCharLenght then nCharLenght = nGuildLenght end
	if nCharLenght > 15 then
		nWidthSize = nWidthSize + ((nCharLenght - 15) * 12)
	end
		
	self.wndMenu:Move(nLeft, nTop-38, nWidthSize, nHeightSize)
	self.wndMenu:Show(true, true)
end

function TheZone:OnTargetMenuClick( wndHandler, wndControl, eMouseButton)

	if (eMouseButton == 0) then
		if tz_uTarget == nil then self:DestroyMenu() return end
		local IdMenu = wndControl:GetData()
		local TargetN = tTargetMenu[IdMenu]
		TargetN.useFunction()
		self:DestroyMenu() 
	end
end

function TheZone:OnPopupClose( wndHandler, wndControl )
	self:DestroyMenu()
end

function TheZone:DestroyMenu()
	if Apollo.FindWindowByName("TargetMenu") then 
   		self.wndMenu:DestroyChildren()		
		self.wndMenu:Destroy()
	end
end

function TheZone:GetFactionLogo(unit)

    local unit = unit
    local nFaction = nil
	if self:IsSameFaction(unit) == true then return tFactionLogo[tTZ_Config.faction] end
	
	if tTZ_Config.faction == 166 then nFaction = 167 
	else nFaction = 166  end
	return tFactionLogo[nFaction]
end

function TheZone:OnClickCountArea( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	if (eMouseButton == 0) then	self.wndCount:FindChild("FrameArea"):Show(not self.wndCount:FindChild("FrameArea"):IsShown()) end
end

function TheZone:INI_OnSave()
	
	local l,t,r,b = self.wndCount:GetAnchorOffsets()
	tTZ_Config.tPosition = { l = l, t = t, r = r, b = b }
	
	for _=1,#tOptionMenu do
		tTZ_Config.option[_] = tOptionMenu[_].bActived
	end
	
	for _=1,#tStatus do
		tTZ_Config.status[_] = tStatus[_].sTextColor
	end
	
	tTZ_Config.tag.healer = tRoleHealer.sIconTag
	return tTZ_Config
end 

function TheZone:OnSave(eLevel)
	
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end 
	local tSavedConfig = self:INI_OnSave()
	return tSavedConfig
end 

function TheZone:INI_OnRestore(tData) 
	
    local tData = tData	
	local tPos = tData.tPosition
	
	if tPos ~= nil then 
		self.wndCount:SetAnchorOffsets(tPos.l, tPos.t, tPos.r, tPos.b)
	end
	
	self.doSetMiniSize = true
	if tData.template ~= nil then tTZ_Config.template = tData.template end
  	
	if tData.option ~= nil then 
		for _=1,#tData.option do
			tOptionMenu[_].bActived = not tData.option[_]
			if tOptionMenu[_].bToggle then
				local wndControl = self.wndCount:FindChild("Option" .. _)
	        	self:OnOptionMenuClick( nil, wndControl, 0)
			end
		end
	end
	
	if tData.faction ~= nil then tTZ_Config.faction = tData.faction end
	if tData.tag.healer ~= nil then tRoleHealer.sIconTag = tData.tag.healer end
	if tData.status ~= nil then
		for _=1,#tData.status do
			tStatus[_].sTextColor = tData.status[_]
		end
    	self:UpdateStatus() 
    end
end 

function TheZone:OnRestore(eLevel,tData) 
	
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end 
	if tData.version == nil then tData = tTZ_Config end
	self:INI_OnRestore(tData) 
end 

function TheZone:TableMerge(t1, t2)
    for k,v in pairs(t2) do
    	if type(v) == "table" then
    		if type(t1[k] or false) == "table" then
    			self:TableMerge(t1[k] or {}, t2[k] or {})
    		else
    			t1[k] = v
    		end
    	else
    		t1[k] = v
    	end
    end
    return t1
end

function TheZone:OnToolTip( wndHandler, wndControl, x, y )
	
	local IdOption = wndControl:GetData()
	local OptionTip = tOptionMenu[IdOption].sToolTips
	wndControl:SetTooltip(OptionTip)
end

function TheZone:OnSizeChanged( wndHandler, wndControl )

	local nAnchor,t,r,b = wndControl:GetAnchorOffsets()
	if self.nLastAnchor ~= nAnchor then
	return end

	self.doArrange = true
end

function TheZone:InitOptionWindow()
	
	self.wndOption = Apollo.LoadForm(self.xmlDoc, "FormOptionWnd", nil, self)
  	self:CreateOptionFrame()
    self.wndOption:Show(true, true)
end

function TheZone:UpdateStatus()
		
	tColorArea.faction = tStatus[1].sTextColor
	tColorArea.nofaction = tStatus[2].sTextColor
	tColorArea.pvpflaged = tStatus[3].sTextColor
	tColorArea.friend = tStatus[4].sTextColor
	tColorArea.group = tStatus[5].sTextColor
	tColorArea.guildmate = tStatus[6].sTextColor	
	tColorArea.dead = tStatus[7].sTextColor
	tColorArea.healerconfirmed = tStatus[8].sTextColor
	tColorArea.tophealer = tStatus[9].sTextColor
	tColorArea.normal = tStatus[10].sTextColor
end

function TheZone:GetSprite(nSprite, sWndControl, sSpriteSuffix)
   
     local nSprite = nSprite 
	 for _= 1, nSprite, 1 do
   		wndSprite = Apollo.LoadForm(self.xmlDoc, "WndSprite_O_", self.wndOption:FindChild(sWndControl), self)
		local sSprite = "NewSprite:" .. sSpriteSuffix .. tostring(_)
       	wndSprite:FindChild("WndSpriteSmall_O_"):SetSprite(sSprite)
	end
    self.wndOption:FindChild(sWndControl):ArrangeChildrenHorz(1)
end

function TheZone:OnSpriteClick( wndHandler, wndControl, eMouseButton)

    local cParent = wndControl:GetParent():GetParent():GetParent():GetName() 
	local sSprite = wndHandler:GetSprite()
	if (eMouseButton == 0) then 
	 	if cParent == "WndFrame2_O_" then 
			self.wndPicture_1:SetSprite(sSprite)
			self.wndPicture_2:SetSprite(sSprite)
			tRoleHealer.sIconTag = "NewSprite:" .. sSprite
	 	end

	 	if cParent == "WndFrame4_O_" then 
			self.wndPicture_3:SetSprite(sSprite)
			tTagOption.sTagSprite = "NewSprite:" .. sSprite 
			self:UpdateTags()
		end
	end
end

function TheZone:CreateOptionFrame()
	
    self.wndOption:FindChild("TitleWnd_O_"):SetText(L["TZ_OPTION_O"])  
	self.wndTitle_Healer = self.wndOption:FindChild("WindTitle_Frame2_O_")  
	self.wndTitle_Healer:SetText(L["TZ_HEALERTAG_O"])
 	self.wndPicture_1 = self.wndOption:FindChild("WndPicture1_Frame2_O_")	
	self.wndPicture_1:FindChild("WindLabel1_Frame2_O_"):SetText(L["TZ_TOPHEALER_O"])
	self.wndPicture_1:SetBGColor(tColorArea.tophealer)
	self.wndPicture_1:SetSprite(tRoleHealer.sIconTag)
	self.wndPicture_1:SetData(9)
	self.wndPicture_1:SetTooltip(L["TZ_TAGCP_O"])
	self.wndPicture_2 = self.wndOption:FindChild("WndPicture2_Frame2_O_") 
	self.wndPicture_2:FindChild("WindLabel2_Frame2_O_"):SetText(L["TZ_HEALER_O"])
    self.wndPicture_2:SetBGColor(tColorArea.healerconfirmed)
    self.wndPicture_2:SetSprite(tRoleHealer.sIconTag)
	self.wndPicture_2:SetData(8)
	self.wndPicture_2:SetTooltip(L["TZ_TAGCP_O"])
	self:GetSprite(16, "WinScroll_Frame2_O_", "healer_")
 	self.wndTitle_Status = self.wndOption:FindChild("WindTitle_Frame1_O_") 
	self.wndTitle_Status:SetText(L["TZ_STATUS_O"])
	self.Combo_Status = self.wndOption:FindChild("Combo_Frame1_O_")
	self.Combo_Status:SetData(1)
    self.Combo_Status:SetTextRaw("   "..tStatus[1].sText)
	self.Combo_Status:SetTextColor(tStatus[1].sTextColor)
    self.Combo_Status:SetData(1) 
	self.wndOption:FindChild("BtnCP_Frame1_O_"):SetTooltip(L["TZ_SHOWCP_O"])
    local nValue = tTZ_Config.opacity
    self.Slider_Background = self.wndOption:FindChild("Slide_Frame3_O_")
	self.Slider_Background:SetTextRaw("     " .. "Set Opacity to " .. tostring(nValue) .. "%") 
   	self.Slider_Background:FindChild("SlideBtn_Frame3_O_"):SetValue(nValue)
	self.wndTitle_Normal = self.wndOption:FindChild("WindTitle_Frame4_O_")  
	self.wndTitle_Normal:SetText(L["TZ_NORMALTAG_O"])
   	self.wndPicture_3 = self.wndOption:FindChild("WndPicture3_Frame4_O_")	
	self.wndPicture_3:SetBGColor(tColorArea.normal)
	self.wndPicture_3:SetSprite(tTagOption.sTagSprite)
	self.wndPicture_3:SetData(10)
	self.wndPicture_3:SetTooltip(L["TZ_TAGCP_O"])
	self:GetSprite(6, "WinScroll_Frame4_O_", "tag_")
end

function TheZone:OnBtnCPClick( wndHandler, wndControl, eMouseButton )
	
    local cParent = wndControl:GetParent():GetName() 
	local sControl = wndControl:GetName()
	if sControl == "WndPicture1_Frame2_O_" or sControl == "WndPicture2_Frame2_O_" or sControl == "WndPicture3_Frame4_O_" then
		self.nIdColor = wndControl:GetData() 
	 	self.nIdControl = wndControl
	end
	
	if sControl == "BtnCP_Frame1_O_" then
	  	self.nIdColor = self.wndOption:FindChild("Combo_Frame1_O_"):GetData()
	 	self.nIdControl = self.wndOption:FindChild("Combo_Frame1_O_")
	end
	self:CP_ShowHide()
end

function TheZone:OnBtnInitClick( wndHandler, wndControl, eMouseButton )

    local cParent = wndControl:GetParent():GetName() 
	if cParent == "WndFrame1_O_" then 
		local nIndex = self.wndOption:FindChild("Combo_Frame1_O_"):GetData() 
		tStatus[nIndex].sTextColor = tStatus[nIndex].sColorIni
		self.nIdColor = nIndex
		self:UpdateComboTxt(self.wndOption:FindChild("Combo_Frame1_O_"), tStatus, self.nIdColor) 
   	end
	
	if cParent == "WndFrame2_O_" then 
		tStatus[8].sTextColor = tStatus[8].sColorIni
		tStatus[9].sTextColor = tStatus[9].sColorIni
		self:UpdateWndSprite(self.wndOption:FindChild("WndPicture1_Frame2_O_"), tStatus, 9) 
	    self:UpdateWndSprite(self.wndOption:FindChild("WndPicture2_Frame2_O_"), tStatus, 8) 
	end
	self:CP_ShowHide()
end

function TheZone:OnComboClick( wndHandler, wndControl, eMouseButton )
	
    local cParent = wndControl:GetParent():GetName() 
	if cParent == "WndFrame1_O_" then 
		if wndControl:GetName() == "Combo_Frame1_O_" then
			self.nIdColor = wndControl:GetData() 
			self.nIdControl = wndControl
			self:UpdateComboList(wndControl, tStatus)
		end
	end
end

function TheZone:OnComboItemClick( wndHandler, wndControl, eMouseButton )

   	local cParent = wndControl:GetParent():GetParent():GetName() 
	local nItem = wndControl:GetData()
	if cParent == "Combo_Frame1_O_" then 
		self.nIdColor = nItem
		self:UpdateComboTxt(self.nIdControl, tStatus, self.nIdColor)
	end
	wndControl:GetParent():Show(false)
	self:CP_ShowHide()
end

function TheZone:UpdateComboTxt(wndControl, tData, nItemIdx)
   
    self:UpdateStatus()
	wndControl:SetTextRaw("   "..tData[nItemIdx].sText)
    wndControl:SetTextColor(tData[nItemIdx].sTextColor)
   	wndControl:SetData(nItemIdx)
end

function TheZone:UpdateWndSprite(wndControl, tData, nItemIdx)
   
    self:UpdateStatus()
	wndControl:SetBGColor(tData[nItemIdx].sTextColor)
    wndControl:SetData(nItemIdx)
	self:UpdateTags()
end

function TheZone:UpdateComboList(wndControl, tItems)

    wndControl:FindChild("ComboList_O_"):DestroyChildren()
    self.arItem = {}   	

	for _= 1, 7 do   
		self.arItem[_] = 
		{
		   	sName = tItems[_].sText,
		    sColor = tItems[_].sTextColor,
			btnItem = Apollo.LoadForm(self.xmlDoc, "BtnComboList_O_", wndControl:FindChild("ComboList_O_"), self)
		}
		
		self.arItem[_].btnItem:SetData(_)
		self.arItem[_].btnItem:SetTextRaw(" "..self.arItem[_].sName)
		self.arItem[_].btnItem:SetTextColor(self.arItem[_].sColor)
	end	

	local nItems = 7 
	local nBtnHeight = self.arItem[1].btnItem:GetHeight()
	local nListHeight = (nItems * nBtnHeight) + nItems
	local l,t,r,b = wndControl:FindChild("ComboList_O_"):GetAnchorOffsets()
	wndControl:FindChild("ComboList_O_"):SetAnchorOffsets(l, t, r, t + nListHeight)
	wndControl:FindChild("ComboList_O_"):ArrangeChildrenVert(1)
	wndControl:FindChild("ComboList_O_"):Show(true, true)
end

function TheZone:OnSlide( wndHandler, wndControl, fNewValue, fOldValue )

    local cParent = wndControl:GetParent():GetParent():GetName() 
	local nNewValue = math.floor(fNewValue + 0.5)
  
	if cParent == "WndFrame3_O_" then 
	   	tTZ_Config.opacity = nNewValue
		self.Slider_Background:SetTextRaw("    Set Opacity to " .. tostring(nNewValue) .. " %") 
		self.wndCount:FindChild("BgWnd"):SetOpacity(nNewValue / 100)
    end
end

function TheZone:OnConfigure()
 	self:ShowHideOption( nil, nil, 0)
end

function TheZone:ShowHideOption( wndHandler, wndControl, eMouseButton)

	if (eMouseButton == 0) then	
		if Apollo.FindWindowByName("FormOptionWnd") then 
			self.wndOption:DestroyChildren()
			self.wndOption:Destroy()
								
			if self.CP_picker ~= nil then 
				self.CP_picker:Destroy()
  				self.CP_picker = nil
			end	
		else
			self:InitOptionWindow()	
			self:CP_Init()
		end
	end		
end

function TheZone:CP_Init( wndHandler, wndControl, eMouseButton)
	GeminiColor = Apollo.GetPackage("GeminiColor").tPackage
end

function TheZone:CP_ShowHide()
	
	 local sActualColor = tStatus[self.nIdColor].sTextColor	
	 if  self.CP_picker ~= nil then 
		self.CP_picker:Destroy()
		self.CP_picker = nil
	 end
	
     self.CP_picker = GeminiColor:CreateColorPicker(self, "CP_Callback", true, sActualColor)
	 local l, t, r, b = self.wndOption:GetAnchorOffsets()  
	 self.CP_picker:Move(l + self.wndOption:GetWidth(), t, self.CP_picker:GetWidth() , self.CP_picker:GetHeight())
	 self.CP_picker:Show(true, true)
end

function TheZone:CP_Callback(sColor)
 
	local sColor = sColor
	local cParent = self.nIdControl:GetParent():GetName() 
	if sColor ~= nil then
		tStatus[self.nIdColor].sTextColor = sColor
	end
	
	if cParent == "WndFrame1_O_" then
    	self:UpdateComboTxt(self.nIdControl, tStatus, self.nIdColor)
    end
    
	if cParent == "WndFrame2_O_" or cParent == "WndFrame4_O_" then
   		self:UpdateWndSprite(self.nIdControl, tStatus, self.nIdColor)
	end
end

function TheZone:SizeTag(wndTag)

	local l,t,r,b = wndTag:GetAnchorOffsets()
	if r == 29 then
		wndTag:SetAnchorOffsets(l - 25, t - 25, r + 25, b + 25)
	end	
end

function TheZone:Set_Arrange(wndControl)

	local nVScrollPos = wndControl:GetVScrollPos() 
	wndControl:ArrangeChildrenTiles(0, function(a,b) return (a:GetData().faction < b:GetData().faction) end)
	wndControl:SetVScrollPos(nVScrollPos)
	self.doArrange = false
end

function TheZone:SetMinimum_Size(wndControl)

    local wndControl = wndControl
	if wndControl == nil then wndControl = self.wndCount end

   	local tChildren = wndControl:FindChild("FrameArea"):GetChildren()
    if #tChildren == 0 then return end 
  	local wnd_TP = tChildren[1]
    local nTP_Width = wnd_TP:GetWidth()
	local nTP_Height = wnd_TP:GetHeight()
	local l,t,r,b = wndControl:FindChild("FrameArea"):GetAnchorOffsets()
	local nR = string.match(r,"%d+")
	local nB = string.match(b,"%d+")
	local nScroll = 14
	local nWidth = nTP_Width + l + nR + nScroll
	local nHeight = nTP_Height + t + nB
	local nScreenWidth, nScreenHeight = Apollo.GetScreenSize()
	
    wndControl:SetSizingMinimum(nWidth, nHeight)
	wndControl:SetSizingMaximum(nScreenWidth, nScreenHeight) 
	
    local nWidth_Mini, nHeight_Mini = wndControl:GetSizingMinimum()
    local nWidth_Actual = wndControl:GetWidth() 
	local nHeight_Actual = wndControl:GetHeight()
	local l,t,r,b = wndControl:GetAnchorOffsets()

	if nWidth_Mini > nWidth_Actual then 
		wndControl:Move(l, t, nWidth_Mini, nHeight_Actual)
	end 
	
	if nHeight_Mini > nHeight_Actual then 
		wndControl:Move(l, t, nWidth_Actual, nHeight_Mini)
	end 
	tChildren = nil
end

function TheZone:GetGuild(uTarget)

    local sGuildName = uTarget:GetGuildName()
    for idx, guildCurr in pairs(GuildLib.GetGuilds()) do
		if guildCurr:GetType() == 1 then sGuildName = guildCurr:GetName() break end
    end 
    return sGuildName
end

function TheZone:GetMemory(sAddOn)

    local sAddOn = sAddOn
	local nMemory = Apollo.GetAddonInfo(sAddOn)
	local nMemUsage = string.format("%10.2f Kb", nMemory.nMemoryUsage / 1024)
	return nMemUsage		
end

function TheZone:GetFPS()

	local nFPS_ = GameLib.GetFrameRate()
	local nFPS = string.format("%10.0f Fps", nFPS_)
	return nFPS		
end

function TheZone:OnBeginDrag( wndHandler, wndControl, x, y, bDragDropStarted )
	self.doArrange = false
end

local TheZoneInst = TheZone:new()
TheZoneInst:Init()

